#include <kernel/tty.h>
#include <kernel/idt.h>
#include <debugging.h>
#include <kernel/elf.h>
#include <kernel/pic.h>

/* Check if the compiler thinks you are targeting the wrong operating system. */
#if defined(__linux__)
#error "You are not using a cross-compiler, you will most certainly run into trouble"
#endif

uint8_t program[] = {
    0xba, 0x09, 0x00, 0x80, 0x00, // mov $string, %edx
    0xcd, 0x80, // int 0x80
    0xeb, 0xfe, // jmp .
    'H',
    'e',
    'l',
    'l',
    'o',
    ' ',
    'W',
    'o',
    'r',
    'l',
    'd', 
    ' ',
    'f',
    'r',
    'o',
    'm',
    ' ',
    'r',
    'i',
    'n',
    'g',
    ' ',
    '3',
    '!',
    0x00,
};

void kernel_main(void) 
{
	/* Initialize terminal interface */
	terminal_initialize();

    init_pic();
    idt_init();
    // run_program(program, sizeof(program));
    while (true) {

    }
}
